## hyprgraphics 0.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

file(READ "${CMAKE_SOURCE_DIR}/VERSION" VER_RAW)
string(STRIP ${VER_RAW} HYPRGRAPHICS_VERSION)
add_compile_definitions(HYPRGRAPHICS_VERSION="${HYPRGRAPHICS_VERSION}")

project(
  hyprgraphics
  VERSION ${HYPRGRAPHICS_VERSION}
  DESCRIPTION
    "Small C++ library for graphics / resource utilities used across the Hypr* ecosystem"
)

include(CTest)
include(GNUInstallDirs)

set(PREFIX ${CMAKE_INSTALL_PREFIX})
set(INCLUDE ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR})

configure_file(hyprgraphics.pc.in hyprgraphics.pc @ONLY)

set(CMAKE_CXX_STANDARD 26)
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)
# -Wno-missing-braces for clang
add_compile_options(
  -Wall
  -Wextra
  -Wpedantic
  -Wno-unused-parameter
  -Wno-unused-value
  -Wno-missing-field-initializers
  -Wno-missing-braces)

if(CMAKE_BUILD_TYPE MATCHES Debug OR CMAKE_BUILD_TYPE MATCHES DEBUG)
  message(STATUS "Configuring hyprgraphics in Debug")
  add_compile_definitions(HYPRGRAPHICS_DEBUG)
else()
  add_compile_options(-O3)
  message(STATUS "Configuring hyprgraphics in Release")
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  add_compile_definitions(__cpp_concepts=202002L)
endif()

file(GLOB_RECURSE SRCFILES CONFIGURE_DEPENDS "src/*.cpp" "include/*.hpp")
file(GLOB_RECURSE PUBLIC_HEADERS CONFIGURE_DEPENDS "include/*.hpp")

find_package(PkgConfig REQUIRED)
pkg_check_modules(
  deps
  REQUIRED
  IMPORTED_TARGET
  pixman-1
  cairo
  pangocairo
  hyprutils
  libjpeg
  libwebp
  libmagic
  libpng
  librsvg-2.0)

pkg_check_modules(
  JXL
  IMPORTED_TARGET
  libjxl
  libjxl_cms
  libjxl_threads
)
if(NOT JXL_FOUND)
  file(GLOB_RECURSE JPEGXLFILES CONFIGURE_DEPENDS "src/*JpegXL.cpp")
  list(REMOVE_ITEM SRCFILES ${JPEGXLFILES})
else()
  add_compile_definitions(JXL_FOUND)
endif()

pkg_check_modules(
  HEIF
  IMPORTED_TARGET
  libheif
)

if(NOT HEIF_FOUND)
  file(GLOB_RECURSE HEIFFILES CONFIGURE_DEPENDS "src/*Avif.cpp")
  list(REMOVE_ITEM SRCFILES ${HEIFFILES})
else()
  add_compile_definitions(HEIF_FOUND)
endif()

add_library(hyprgraphics SHARED ${SRCFILES})
target_include_directories(
  hyprgraphics
  PUBLIC "./include"
  PRIVATE "./src")
set_target_properties(hyprgraphics PROPERTIES VERSION ${HYPRGRAPHICS_VERSION}
                                              SOVERSION 1)
target_link_libraries(hyprgraphics PkgConfig::deps)
if(JXL_FOUND)
  target_link_libraries(hyprgraphics PkgConfig::JXL)
endif()

if(HEIF_FOUND)
  target_link_libraries(hyprgraphics PkgConfig::HEIF)
endif()

# tests
add_custom_target(tests)

add_executable(hyprgraphics_image "tests/image.cpp")
target_link_libraries(hyprgraphics_image PRIVATE hyprgraphics PkgConfig::deps)
add_test(
  NAME "Image"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND hyprgraphics_image "image")
add_dependencies(tests hyprgraphics_image)
add_executable(hyprgraphics_arg "tests/arg.cpp")
target_link_libraries(hyprgraphics_arg PRIVATE hyprgraphics PkgConfig::deps)
add_test(
  NAME "ARG"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND hyprgraphics_arg "image")
add_dependencies(tests hyprgraphics_arg)

# Installation
install(TARGETS hyprgraphics)
install(DIRECTORY "include/hyprgraphics"
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${CMAKE_BINARY_DIR}/hyprgraphics.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

## hyprgraphics 0.1.5

=== debian/changelog ===
hyprgraphics (0.1.5-1) unstable; urgency=medium

  * Initial release. (Closes: #1099341)

 -- Carl Keinath <carl.keinath@gmail.com>  Mon, 28 Jul 2025 11:48:50 +0200

=== debian/control ===
Source: hyprgraphics
Section: libs
Priority: optional
Maintainer: Carl Keinath <carl.keinath@gmail.com>
Uploaders: Alan M Varghese (NyxTrail) <alan@digistorm.in>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkgconf,
 g++-14,
 libpixman-1-dev,
 libcairo2-dev,
 libhyprutils-dev (>= 0.2.2),
 libjpeg-dev,
 libwebp-dev,
 libmagic-dev,
 libspng-dev,
 libjxl-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/hyprwm/hyprgraphics
Vcs-Browser: https://salsa.debian.org/carlo711/hyprgraphics
Vcs-Git: https://salsa.debian.org/carlo711/hyprgraphics.git
Description: C++ graphics utility library for Hyprland
 Hyprgraphics is a small C++ library with graphics / resource related utilities
 used across the hypr* ecosystem.

Package: libhyprgraphics-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libhyprgraphics0 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}

Package: libhyprgraphics0
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: ${source:Synopsis} - library
 ${source:Extended-Description}

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_clean:
	rm -rf tests/test_output
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_CXX_STANDARD=26

=== debian/watch ===
version=4
opts="mode=git,pgpmode=gittag" \
    https://github.com/hyprwm/hyprgraphics.git \
    refs/tags/v@ANY_VERSION@

## hyprgraphics 0.2.0

=== debian/changelog ===
hyprgraphics (0.2.0-2) unstable; urgency=medium

  * d/patches: fix FTBFS on big endian

 -- Carl Keinath <carl.keinath@gmail.com>  Fri, 24 Oct 2025 12:46:49 +0200

hyprgraphics (0.2.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1099341)

 -- Carl Keinath <carl.keinath@gmail.com>  Wed, 08 Oct 2025 16:09:53 +0200

=== debian/control ===
Source: hyprgraphics
Section: libs
Priority: optional
Maintainer: Debian Hyprland Maintainers <team+hyprland@tracker.debian.org>
Uploaders:
 Carl Keinath <carl.keinath@gmail.com>,
 Chow Loong Jin <hyperair@debian.org>,
 Alan M Varghese (NyxTrail) <alan@digistorm.in>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkgconf,
 libpixman-1-dev,
 libcairo2-dev,
 libpango1.0-dev,
 libhyprutils-dev (>= 0.2.2),
 libjpeg-dev,
 libwebp-dev,
 libmagic-dev,
 libspng-dev,
 librsvg2-dev,
 libjxl-dev,
 libheif-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/hyprwm/hyprgraphics
Vcs-Browser: https://salsa.debian.org/hyprland-team/hyprgraphics
Vcs-Git: https://salsa.debian.org/hyprland-team/hyprgraphics.git
Description: C++ graphics utility library for Hyprland
 Hyprgraphics is a small C++ library with graphics / resource related utilities
 used across the hypr* ecosystem.

Package: libhyprgraphics-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libhyprgraphics1 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}

Package: libhyprgraphics1
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: ${source:Synopsis} - library
 ${source:Extended-Description}

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_clean:
	rm -rf tests/test_output
	dh_auto_clean

## hyprgraphics 0.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -95,7 +95,7 @@
   PUBLIC "./include"
   PRIVATE "./src")
 set_target_properties(hyprgraphics PROPERTIES VERSION ${HYPRGRAPHICS_VERSION}
-                                              SOVERSION 1)
+                                              SOVERSION 2)
 target_link_libraries(hyprgraphics PkgConfig::deps)
 if(JXL_FOUND)
   target_link_libraries(hyprgraphics PkgConfig::JXL)

=== debian/changelog ===
hyprgraphics (0.3.0-2) unstable; urgency=medium

  * Reupload to unstable

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 11 Nov 2025 17:50:02 +0800

hyprgraphics (0.3.0-1) experimental; urgency=medium

  * New upstream release
  * Bump shared library SONAME to 2:
    - Renamed binary package to libhyprgraphics2
  * d/control: add libhyprgraphics2 binary

 -- Carl Keinath <carl.keinath@gmail.com>  Sat, 08 Nov 2025 13:41:05 +0100

=== debian/control ===
--- 
+++ 
@@ -35,12 +35,12 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libhyprgraphics1 (= ${binary:Version}),
+ libhyprgraphics2 (= ${binary:Version}),
  ${misc:Depends},
 Description: ${source:Synopsis} - development files
  ${source:Extended-Description}
 
-Package: libhyprgraphics1
+Package: libhyprgraphics2
 Architecture: any
 Multi-Arch: same
 Depends:

=== debian/watch ===
Version: 5

Template: Github
Owner: hyprwm
Project: hyprgraphics

## hyprgraphics 0.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -95,7 +95,7 @@
   PUBLIC "./include"
   PRIVATE "./src")
 set_target_properties(hyprgraphics PROPERTIES VERSION ${HYPRGRAPHICS_VERSION}
-                                              SOVERSION 2)
+                                              SOVERSION 3)
 target_link_libraries(hyprgraphics PkgConfig::deps)
 if(JXL_FOUND)
   target_link_libraries(hyprgraphics PkgConfig::JXL)

=== debian/changelog ===
hyprgraphics (0.4.0-3) unstable; urgency=medium

  [ Julian Sax ]
  * Add -dev deps which are included in header files

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 17 Dec 2025 18:45:23 +0800

hyprgraphics (0.4.0-2) unstable; urgency=medium

  * Reupload to unstable

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 24 Nov 2025 14:56:00 +0800

hyprgraphics (0.4.0-1) experimental; urgency=medium

  * New upstream release
  * Bump shared library SONAME to 3:
    - Renamed binary package to libhyprgraphics3

 -- Carl Keinath <carl.keinath@gmail.com>  Fri, 21 Nov 2025 23:14:55 +0100

=== debian/control ===
--- 
+++ 
@@ -35,12 +35,14 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libhyprgraphics2 (= ${binary:Version}),
+ libhyprgraphics3 (= ${binary:Version}),
+ libcairo2-dev,
+ libhyprutils-dev (>= 0.2.2),
  ${misc:Depends},
 Description: ${source:Synopsis} - development files
  ${source:Extended-Description}
 
-Package: libhyprgraphics2
+Package: libhyprgraphics3
 Architecture: any
 Multi-Arch: same
 Depends:

## hyprgraphics 0.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -95,7 +95,7 @@
   PUBLIC "./include"
   PRIVATE "./src")
 set_target_properties(hyprgraphics PROPERTIES VERSION ${HYPRGRAPHICS_VERSION}
-                                              SOVERSION 3)
+                                              SOVERSION 4)
 target_link_libraries(hyprgraphics PkgConfig::deps)
 if(JXL_FOUND)
   target_link_libraries(hyprgraphics PkgConfig::JXL)

=== debian/changelog ===
hyprgraphics (0.5.0-2) unstable; urgency=medium

  * Reupload to unstable

 -- Chow Loong Jin <hyperair@debian.org>  Sat, 03 Jan 2026 14:18:03 +0800

hyprgraphics (0.5.0-1) experimental; urgency=medium

  * New upstream version 0.5.0
  * Rename packages for soname bump

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 29 Dec 2025 23:52:28 +0800

=== debian/control ===
--- 
+++ 
@@ -35,14 +35,14 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libhyprgraphics3 (= ${binary:Version}),
+ libhyprgraphics4 (= ${binary:Version}),
  libcairo2-dev,
  libhyprutils-dev (>= 0.2.2),
  ${misc:Depends},
 Description: ${source:Synopsis} - development files
  ${source:Extended-Description}
 
-Package: libhyprgraphics3
+Package: libhyprgraphics4
 Architecture: any
 Multi-Arch: same
 Depends:
